#include "Group.h"
#include <fstream>

Group::Group(int s) // 
{
	Size = s;
	Array = new Student[Size];
}
Group::~Group() // 
{
	delete[] Array;
}

Student& Group:: operator [](int i) //
{
	return Array[i];
}

//   student    i .
// i>Size,    error  
void Group::PutStudent(int i, Student& St, int&error)
{
	if (i >= Size)
		error = 3;  // 
	else
		Array[i] = St;
}

//     ""
int Group::CalcCountGoodGrade()
{
	int k = 0;
	for (int i = 0; i < Size; i++)
	{
		if (Array[i].HasGoodGrade())
			k++;
	}
	return k;
}

//       
void Group::CalcAverageGrade()
{
	for (int i = 0; i < Size; i++)
		Array[i].CalcAverage();
}

//    Array
int Group::GetSize() 
{
	return Size;
}

//  i-  Array
Student& Group::GetStudent(int i)
{
	return Array[i];
}

/*        file.
*          Group,
*       
*      ,     error.
*/
Group* ReadDataFromTxt(const char* file, int& error)
{
	error = 0;
	std::string surname, name;
	int mark[4], N, k = 0;
	std::ifstream in(file);
	if (in.is_open())
	{
		in >> N;
		if (N <= 0) 
		{
			error = 2; //:   N
			return NULL;
		}
		else
		{
			Group* group = new Group(N);
			while (!in.eof())
			{
				in >> surname >> name;
				for (int i = 0; i < 4 && !in.fail(); i++) {
					in >> mark[i];
					
					if((mark[i]<2 || mark[i]>5) && !in.fail()) 
					{
						//:    [2;5]
						error = 5;
						return NULL;
					}
					
				}
				if (in.fail())  //    
				{
					error = 4;
					return NULL;
				}
				Student St(surname, name, mark);
				group->PutStudent(k, St, error);
				k++;
			}
			in.close();
			return group;
		}
	}
	else
	{   //   
		error = 1; 
		return NULL;
	}
}

